#include <iostream>
#include <fstream>
#include <queue>
#include <cstring>
using namespace std;

ifstream f("livada.in");
ofstream g("livada.out");

queue < pair<int,int> > coada;
int Map[103][103];
int di[8]={0,0,-1,1,1,1,-1,-1};
int dj[8]={-1,1,0,0,-1,1,-1,1};
int n,m,startx,starty,stopx,stopy;
char x[200];
void citire(){
    f>>n>>m;
    f>>startx>>starty;
    f>>stopx>>stopy;
    for(int i=1;i<=n;i++){
        // Ii bun :)
        for(int j=1;j<=m;j++){
            f>>x;
            char nr_voc=0;
            for(int tz=0;x[tz];tz++){
                if(strchr("aeiou",x[tz])) nr_voc++;
            }
            if(nr_voc!=1) Map[i][j]=-1; /// Obstacol
        }
    }
}

bool ok(int i,int j){
    if(i<1 || j<1 || i>n || j>m ) return false;
    if(Map[i][j]==-1) return false;
    return true;
}

void lee(){
    int i,j,i2,j2;
    Map[startx][starty] = 1;
    coada.push(make_pair(startx,starty));
    while(!coada.empty()){
        i=coada.front().first;
        j=coada.front().second;
        coada.pop();
        for(int dir=0;dir<8;dir++){
            i2=i+di[dir];
            j2=j+dj[dir];
            if(ok(i2,j2) && Map[i2][j2]!= -1){
                Map[i2][j2]=Map[i][j]+1;
                coada.push(make_pair(i2,j2));
            }
        }
    }
}

int main()
{
    citire();
    //cout<<"Tesnt \n";
    lee();
    cout<<Map[stopx][stopy];
    return 0;
}
