#include <iostream>
#include <cstdio>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;

pair < int , pair < int ,int > > v1[200005],v2[200005];

int n,m,tata[200005],mar[200005],contor[200005];
int cmp(pair < int , pair < int ,int > > a, pair < int , pair < int ,int > > b)
{
    if (a.second.first==b.second.first)
        return a.second.second <= b.second.second;
    return a.second.first < b.second.first;
}
void citire()
{
    scanf("%d%d",&n,&m);
    for (int i=1;i<=m;++i)
    {
        int x,y;
        scanf("%d%d",&x,&y);
        v1[i]=make_pair(i,make_pair(x,y));
        v2[i]=make_pair(i,make_pair(y,x));
        tata[i]=i;
        mar[i]=1;
    }
    sort(v1+1,v1+m+1,cmp);///sortare dupa linie
    sort(v2+1,v2+m+1,cmp);///sortare dupa coloana
}
int caut_rad(int k)
{
    int poz=tata[k];
    while (tata[poz]!=poz)
        poz=tata[poz];
    while (tata[k]!=poz)
    {
        int aux=tata[k];
        tata[k]=poz;
        k=aux;
    }
    return poz;
}
void unite(int x,int y)
{
    if (x==y)
        return;
    if (mar[x]<mar[y])
    {
        tata[x]=y;
        mar[y]+=mar[x];
        mar[x]=0;
    }
    else
    {
        tata[y]=x;
        mar[x]+=mar[y];
        mar[y]=0;
    }
}
void solve1()
{
    for (int i=1;i<=m;++i)
        if (v1[i].second.first==v1[i+1].second.first && v1[i].second.second==(v1[i+1].second.second-1))
            unite(caut_rad(v1[i].first),caut_rad(v1[i+1].first));
}
void solve2()
{
    for (int i=1;i<=m;++i)
        if (v2[i].second.first==v2[i+1].second.first && v2[i].second.second==(v2[i+1].second.second-1))
            unite(caut_rad(v2[i].first),caut_rad(v2[i+1].first));
}
int main()
{
    freopen("mozaic.in","r",stdin);
    freopen("mozaic.out","w",stdout);
    citire();
    solve1();
    solve2();
    int s=0;
    for (int i=1;i<=m;++i)
        {
            if (mar[i])
                ++s;
            contor[mar[i]]++;
        }
    printf("%d\n",s);
    int i=1;
    while (s)
    {
        s-=contor[i];
        if (contor[i])
            printf("%d %d\n",i,contor[i]);
        ++i;
    }
    return 0;
}
