#include <cstdio>
#include <vector>
#include <algorithm>
#define nmax 2005

using namespace std;

int n,k,nr[nmax*nmax],num,nrcomp;
bool viz[nmax*nmax];
int di[5]={0,1,-1,0};
int dj[5]={-1,0,0,1};
pair<int,int> a[nmax*nmax];
vector<int> g[nmax*nmax];

void citire()
{
    int x,y;
    scanf("%d%d",&n,&k);
    for(int i=1;i<=k;i++)
    {
        scanf("%d%d",&x,&y);
        a[i]=make_pair(x,y);
    }
}

int compar(int i,int j,int x,int y)
{
    if(i<x)
        return -1;
    if(i==x)
    {
        if(j<y)
            return -1;
        if(j==y)
            return 0;
        return 1;
    }
    return 1;
}

int caut_bin(int li,int lf,int x,int y)
{
    int m=(li+lf)/2,rez;
    while(li<=lf)
    {
        m=(li+lf)/2;
        rez=compar(a[m].first,a[m].second,x,y);
        if(rez<0)
            li=m+1;
        else
        if(rez>0)
            lf=m-1;
        else
            return m;
    }
    return -1;
}

void constructie_graf()
{
    int in,jn,pz;
    for(int i=1;i<=k;i++)
    {
        for(int q=0;q<=3;q++)
        {
            in=a[i].first+di[q];
            jn=a[i].second+dj[q];
            if(in>=1&&in<=n&&jn>=1&&jn<=n)
            {
                pz=caut_bin(1,i-1,in,jn);
                if(pz>0)
                {
                    g[pz].push_back(i);
                    g[i].push_back(pz);
                }
            }
        }
    }
}

void dfs(int k)
{
    viz[k]=1;
    num++;
    for(vector<int>::iterator ii=g[k].begin();ii!=g[k].end();++ii)
        if(!viz[*ii])
            dfs(*ii);
}

void rezolv()
{
    for(int i=1;i<=k;i++)
        if(viz[i]==0)
        {
            num=0;
            dfs(i);
            nr[num]++;
            nrcomp++;
        }
}

void afisare()
{
    printf("%d\n",nrcomp);
    for(int i=1;i<=k;i++)
        if(nr[i])
            printf("%d %d\n",i,nr[i]);

}

int main()
{
    freopen("mozaic.in","r",stdin);
    freopen("mozaic.out","w",stdout);
    citire();
    sort(a+1,a+k+1);
    constructie_graf();
    rezolv();
    afisare();
    /*printf("\n");
    for(int i=1;i<=k;i++)
        for(vector<int>::iterator ii=g[i].begin();ii!=g[i].end();++ii)
            printf("%d %d\n",i,*ii);*/
    return 0;
}
