#include <cstdio>
#include <vector>
#include <cstring>
#include <queue>

#define NMAX 200005
#define INF 0x3f3f3f3f

#define pb push_back
#define mp make_pair

using namespace std;

int n,m;
int viz[NMAX];
vector<int> g[NMAX];

void read()
{
    int a,b,c;
    scanf("%d%d",&n,&m);
    for(int i=1;i<=m;++i)
    {
        scanf("%d%d",&a,&b);
        g[a].pb(b);
        g[b].pb(a);
    }
}

int solve()
{
    int nr=0,k=1;
    viz[k]=1;///echipa 1
    queue<int> q;
    for(q.push(k);!q.empty();q.pop())
    {
        k=q.front();
        ++nr;
        vector<int>::iterator it;
        for(it=g[k].begin();it!=g[k].end();++it)
            if(!viz[*it])
            {
                viz[*it]=(viz[k]==1?2:1);
                q.push(*it);
            }
    }
    /*
    ///nod neconex cu restul grafului => echipa 2
    for(int i=1;i<=n;++i)
        if((!viz[i])&&(!g[i].size()))
        {
            viz[i]=2;
            ++nr;
        }
    */
    return nr;
}

void print()
{
    for(int i=1;i<=n;++i)
        if(!(viz[i]-1))
            printf("%d ",i);
    printf("\n");
    for(int i=1;i<=n;++i)
        if(!(viz[i]-2))
            printf("%d ",i);
    printf("\n");
}

int main()
{
    freopen("hogwarts.in","r",stdin);
    freopen("hogwarts.out","w",stdout);
    read();
    if(solve()==n)
        print();
    else
        printf("-1\n");
    return 0;
}
