#include <iostream>
#include <fstream>
#include <cstring>
#include <queue>

using namespace std;

queue < pair <int,int> > coada;

int di[8]={-1,1,-1,1, 1,-1,0,0};
int dj[8]={-1,1,1,-1, 0,0,1,-1};

ifstream fin("livada.in");
ofstream fout("livada.out");

int Map[100][100];
int M,N;
int startx, starty, stopx, stopy;

int voc(char s[])
{   int nr=0;
    int n=strlen(s);
    for(int i=1; i<n; i++)
        if(strchr("aeiou",s[i])) nr++;
    return nr;
}

void Read()
{   char s[20];
    int i,j;
    for(i=1; i<=N; i++)
        for(j=1; j<=M; j++)
    {
        fin>>s;
        if(voc(s)!=1) Map[i][j]=-1;
        else Map[i][j]=0;
    }
    return;
}

int isok(int i, int j)
{
    if(i>N||j>N||i<1||j<1) return 0;
    if(Map[i][j]==-1) return 0;
    //if( voc(Map[i][j])!=1) return 0;
    return 1;
}

int Lee()
{
    int i,j, i1, j1, MAX=0;
    Map[startx][starty]=1;
    Map[stopx][stopy]=25;
    coada.push(make_pair(startx,starty));
    while(!coada.empty())
    {
        i=coada.front().first;
        j=coada.front().second;
        coada.pop();
        for(int directie=0; directie<=7; directie++)
        {
            i1=i+di[directie];
            j1=j+dj[directie];
            if( isok(i1,j1)!=0 && Map[i1][j1]<1)
            {
                Map[i1][j1]=Map[i][j]+1;
                coada.push(make_pair(i1,j1));
                if(Map[i][j]>MAX) MAX=Map[i][j];
            }
        }

    }
return MAX;
}

void drumul(int MAX)
{   int i,j;
    while(MAX){
    for( i=1; i<=N; i++)
        {for( j=1; j<=M; j++)
            if(Map[i][j]>MAX)
            {   MAX=Map[i][j];
                fout<<"("<<j<<","<<i<<") ";
                break;
            }
        if(Map[i][j]==MAX) break;
        }
    MAX--;
    }
    return;
}
int main()
{   int MAX;
    fin>>N>>M>>startx>>starty>>stopx>>stopy;
    Read();
    MAX=Lee();

    //afish();
    drumul(MAX);
    return 0;
}
