#include <iostream>
#include <cstring>
#include <fstream>
#include <queue>

using namespace std;

ifstream f("livada.in");
ofstream g("livada.out");
int Map[200][200];
int startx, starty, stopx,stopy;
int N,M;
char s[600];

void Read1()
{
    f>>N>>M;
    f>>startx>>starty;
    f>>stopx>>stopy;
    f.get();
}
int lin=1,col;
void Read2()
{
    char *p,*q;
    int nr=0;
    for(int i=1; i<=N; i++)
    {
        f.get(s,600);
        f.get();
        col=1;
        for(p=strtok(s," "); p; p=strtok(NULL," " ))
        {
            if(!strcmp(p,"copac")) Map[lin][col++]=-1;
            else if(!strcmp(p,"cais")) Map[lin][col++]=-1;
            else Map[lin][col++]=0;
        }
        lin++;
    }
    lin--;
    col--;

}

int OK(int i, int j)
{
    if(i<1||j<1||i>N||j>M) return 0;
    if(Map[i][j]==-1) return 0;
    else return 1;
}

queue < pair <int,int> > Q;

int di[8]= {0,0,1,-1,-1,-1,1,1};
int dj[8]= {-1,1,0,0,-1,1,-1,1};


void Lee()
{
    int i,j,i1,j1;
    Map[startx][starty]=1;
    Q.push(make_pair(startx,starty));
    while(!Q.empty())
    {
        i=Q.front().first;
        j=Q.front().second;
        Q.pop();
        for(int dir=0; dir<8; dir++)
        {
            i1=i+di[dir];
            j1=j+dj[dir];
            if(OK(i1,j1)&&Map[i1][j1]<1)
            {
                Map[i1][j1]=Map[i][j]+1;
                Q.push(make_pair(i1,j1));
            }
        }
    }

}

int main()
{
    int vect1[600],vect2[600];
    int k1=1,k2=1,j1,i1,nr,i,j,max=-1;;
    Read1();
    Read2();
    Lee();
    /*  for( i=1;i<=lin;i++)
       {for(j=1;j<=col;j++)
          cout<<Map[i][j]<<" ";
          cout<<"\n";} */

    i=stopx;
    j=stopy;
    nr=Map[stopx][stopy];

    while(nr)
    {
        nr--;
        vect1[k1++]=i;
        vect2[k2++]=j;
        for(int dir=0; dir<8; dir++)
        {
            i1=i+di[dir];
            j1=j+dj[dir];
            if(Map[i1][j1]==nr)
            {
                i=i1;
                j=j1;
                dir=9;
            }
        }
    }

    for(i=k1-1; i>0; i--)
        g<<"("<<vect1[i]<<","<<vect2[i]<<")";


    return 0;
}
