#include <iostream>
#include <cstdio>
#include <queue>

using namespace std;
queue < pair < int, int > > q;
int n, k, a[2500][2500], nr, v[2000], mark;
int vi[4] = {0, -1, 0, 1};
int vj[4] = {1, 0, -1, 0};

void citire()
{
    freopen("mozaic.in", "r", stdin);
    freopen("mozaic.out", "w", stdout);
    scanf("%d%d", &n, &k);
    for(int i=1; i<=k ;i++)
    {
        int x, y;
        scanf("%d%d", &x, &y);
        a[x][y] = -2;
    }
}

void bordare()
{
    for(int i=0; i<=n+1; i++)
    {
        a[0][i] = -1;
        a[n+1][i] = -1;
    }
    for(int i=1; i<=n; i++)
    {
        a[i][0] = -1;
        a[n+1][0] = -1;
    }
}

void cautare(int x, int y)
{
    nr = 1;
    q.push(make_pair(x, y));
    while(!q.empty())
    {
        x = q.front().first;
        y = q.front().second;
        a[x][y] = mark;
        q.pop();
        for(int i=0; i<4; i++)
        {
            if(a[x+vi[i]][y+vj[i]] == -2)
            {
                q.push(make_pair(x+vi[i], y+vj[i]));
                a[x+vi[i]][y+vj[i]] = mark;
                nr++;
            }
        }
    }
}

void solve()
{
    for(int i=1; i<=n; i++)
        for(int j=1; j<=n; j++)
            if(a[i][j] == -2)
            {
                mark++;
                cautare(i, j);
                v[nr]++;
            }
}

int main()
{
    citire();
    bordare();
    solve();
    printf("%d \n", mark);
    for(int i=1; i<=n*n; i++)
        if(v[i])
            printf("%d %d \n", i, v[i]);

    return 0;
}
