#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <queue>

#define NMAX 200005

#define x first
#define y second

using namespace std;

int n,nr;
int viz[NMAX];
pair<int,int> p[NMAX];
vector<pair<int,int> > Ans;


void read()
{
    int auics;
    scanf("%d%d",&auics,&n);
    for(int i=1;i<=n;++i)
        scanf("%d%d",&p[i].x,&p[i].y);
}

void solve()
{
    for(int i=1;i<=n;++i)
        if(!viz[i])
        {
            int dimen=1;
            viz[i]=++nr;
            queue<int> q;
            for(q.push(i);!q.empty();q.pop())
            {
                int k=q.front();
                for(int j=i+1;j<=n;++j)
                    if(!viz[j]&&abs(p[k].x-p[j].x)+abs(p[k].y-p[j].y)==1)
                    {
                        ++dimen;
                        viz[j]=nr;
                        q.push(j);
                    }
            }
            int exists=0;
            vector<pair<int,int> >::iterator it;
            for(it=Ans.begin();it!=Ans.end();++it)
                if(it->first==dimen)
                {
                    ++it->second;
                    exists=1;
                }
            if(!exists)
                Ans.push_back(make_pair(dimen,1));
        }
    sort(Ans.begin(),Ans.end());
}

void print()
{
    printf("%d\n",nr);
    vector<pair<int,int> >::iterator it;
    for(it=Ans.begin();it!=Ans.end();++it)
        printf("%d %d\n",it->first,it->second);
}

int main()
{
    freopen("mozaic.in","r",stdin);
    freopen("mozaic.out","w",stdout);
    read();
    solve();
    print();
    return 0;
}
