#include <cstdio>
#include <vector>
#include <queue>

using namespace std;

const int nmx = 200002;

int n,m;
bool incomplet = 0;
char echipa[nmx];
vector <int> g[nmx];

void citire() {
    scanf("%d %d", &n, &m);
    int nod1,nod2;
    for(int i = 1; i <= m; ++i) {
        scanf("%d %d", &nod1, &nod2);
        ///printf("%d %d\n",nod1,nod2);
        g[nod1].push_back(nod2);
        g[nod2].push_back(nod1);
    }
}

void parcurgere() {
    queue <int> q;
    echipa[1] = 1;
    q.push(1);
    while(not q.empty()) {
        int nod = q.front();
        q.pop();
        for(vector<int>::iterator it = g[nod].begin(); it != g[nod].end(); ++it)
            if(not echipa[*it]) {
                if(echipa[nod] == 1)
                    echipa[*it] = 2;
                else
                    echipa[*it] = 1;
                q.push(*it);
            } else if((echipa[*it] + echipa[nod]) % 2 == 0) {
                printf("-1\n");
                incomplet = 1;
                return;
            }
    }
}

int main() {
    freopen("hogwarts.in", "r", stdin);
    freopen("hogwarts.out", "w", stdout);

    citire();

    parcurgere();

    if(incomplet == 0) {
        for(int i = 1; i <= n; ++i)
            if(echipa[i] == 0) {
                printf("-1\n");
                incomplet = 1;
                return 0;
            }

        if(incomplet == 0) {
            for(int i = 1; i <= n; ++i)
                if(echipa[i] == 1)
                    printf("%d ", i);
            printf("\n");
            for(int i = 1; i <= n; ++i)
                if(echipa[i] == 2)
                    printf("%d ", i);
            printf("\n");
        }
    }

    return 0;
}
